// TsUtilClass.cpp: TS[eBeB[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsUtilClass.h"


//////////////////////////////////////////////////////////////////////
// CDynamicReferenceable NX̍\z/
//////////////////////////////////////////////////////////////////////

CDynamicReferenceable::CDynamicReferenceable()
	: m_dwRefCount(0UL)
{

}

CDynamicReferenceable::~CDynamicReferenceable()
{

}

void CDynamicReferenceable::AddRef(void)
{
	// QƃJEgCNg
	m_dwRefCount++;
}

void CDynamicReferenceable::ReleaseRef(void)
{
	// QƃJEgfNg
	if(m_dwRefCount){
		// CX^XJ
		if(!(--m_dwRefCount))delete this;
		}
#ifdef _DEBUG
	else{
		::DebugBreak();
		}
#endif
}


//////////////////////////////////////////////////////////////////////
// CCriticalLock NX̍\z/
//////////////////////////////////////////////////////////////////////

CCriticalLock::CCriticalLock()
{
	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CCriticalLock::~CCriticalLock()
{
	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Lock(void)
{
	// NeBJZNV擾
	::EnterCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Unlock(void)
{
	// NeBJZNVJ
	::LeaveCriticalSection(&m_CriticalSection);
}

bool CCriticalLock::TryLock(void)
{
	return ::TryEnterCriticalSection(&m_CriticalSection)!=FALSE;
}


//////////////////////////////////////////////////////////////////////
// CBlockLock NX̍\z/
//////////////////////////////////////////////////////////////////////

CBlockLock::CBlockLock(CCriticalLock *pCriticalLock)
	: m_pCriticalLock(pCriticalLock)
{
	// bN擾
	m_pCriticalLock->Lock();
}

CBlockLock::~CBlockLock()
{
	// bNJ
	m_pCriticalLock->Unlock();
}


CTryBlockLock::CTryBlockLock(CCriticalLock *pCriticalLock)
	: m_pCriticalLock(pCriticalLock)
	, m_bLocked(false)
{
}

CTryBlockLock::~CTryBlockLock()
{
	if (m_bLocked)
		m_pCriticalLock->Unlock();
}

// 蔲̂߂TimeOutۂ̑҂Ԃ͑
bool CTryBlockLock::TryLock(DWORD TimeOut)
{
	for (DWORD i=TimeOut;i>0;i--) {
		if (m_pCriticalLock->TryLock()) {
			m_bLocked=true;
			break;
		}
		Sleep(1);
	}
	return m_bLocked;
}
